clear all
close all
clc

x = -2:2;
f = [-25, -4, -1, 8, 47];

% Calcular los polinomios pedidos. polyfit retorna los coeficientes del
% polinomio de la forma p(x) CN*x^N + ... + C1*x + C0
p1 = polyfit(x, f, 1);
p2 = polyfit(x, f, 2);
p3 = polyfit(x, f, 3);
p4 = polyfit(x, f, 4);
p5 = polyfit(x, f, 5);

% Crear vector x para evaluar los polinomios obtenidos
xx = linspace(-2, 2, 200);

figure(1)
plot(x, f, '*k'); hold on; grid on
plot(xx, polyval(p1, xx), 'r')
plot(xx, polyval(p2, xx), 'g')
plot(xx, polyval(p3, xx), 'b')
plot(xx, polyval(p4, xx), 'm')
plot(xx, polyval(p5, xx), 'y')
xlabel('eje x')
ylabel('eje y')
title('Polinomios ajustados por min cuadrados')
legend('puntos', 'p_1', 'p_2', 'p_3', 'p_4', 'p_5')

q = [1, 0, -1, 3, 6, -1];
figure(2)
plot(x, f, '*k'); hold on; grid on
plot(xx, polyval(q, xx), 'r')
legend('puntos', 'q')
xlabel('eje x')
ylabel('eje y')

% p3 y p4 son el mismo polinomio. El teorema dice que existe un unico
% polinomio de grado <= n, cuando se tienen n + 1 puntos, por lo tanto no
% se contradice. q interpola los puntos, pero q es de grado 5, que es mayor
% que n (en este caso 4, pues hay 5 puntos). Por lo tanto no se contradice
% el teorema.

