clear all
close all
clc

% Puntos pedidos
x = 1:3;
f = log(x);

p = polyfit(x, f, 2);
xx = linspace(1, 3, 200);

figure(1)
plot(x, f, '*r'); hold on; grid on
plot(xx, log(xx), 'g')
plot(xx, polyval(p, xx), 'b')
legend('puntos', 'f(x)', 'p(x)')
xlabel('eje x')
ylabel('eje y')

h = 1/50;
xi = 1:h:3;

error_abs = abs(log(xi) - polyval(p, xi));
cota = 1/3 * abs((xi - 1) .* (xi - 2) .* (xi - 3));

figure(2)
plot(xi, error_abs, 'b'); hold on; grid on
plot(xi, cota, 'r')
legend('error absoluto', 'cota del error')

