clear all
close all
clc

x = [.9, 1.3, 1.9, 2.1, 2.6, 3, 3.9, 4.4, 4.7, 5, 6, 7, 8, 9.2, 10.5, ...
    11.3, 11.6, 12, 12.6, 13, 13.3];
y = [1.3, 1.5, 1.85, 2.1, 2.6, 2.7, 2.4, 2.15, 2.05, 2.1, 2.25, 2.3, ...
    2.25, 1.95, 1.4, 0.9, 0.7, 0.6, 0.5, 0.4, 0.25];

% Se tienen n + 1 puntos, por lo tanto el polinomio sera de grado n.
p = polyfit(x, y, length(x) - 1);

xx = linspace(0.9, 13.3, 100);

figure(1)
plot(x, y, '*r'); hold on; grid on
plot(xx, polyval(p, xx), 'b')
legend('puntos', 'polinomio de interpolacion')

% El polinomio no es una buena aproximacion, tiene oscilaciones en los
% extremos y no forma el contorno deseado (fenomeno de runge).

s = csape(x, [0, y, 0], [2, 2]);

figure(2)
plot(x, y, '*r'); hold on; grid on
plot(xx, fnval(s, xx), 'b')
legend('puntos', 'spline cubico natural')