clear all
close all
clc

xi = 0:.5:10;
yi = [2.5, 2.8, 3, 3.3, 3.8, 4.8, 4.8, 5, 4.8, 4.7, 4.7, 4.5, 4.5, 4.4, ...
    4.3, 4.4, 4.2, 4, 4.1, 4.3, 3.5];

p = polyfit(xi, yi, length(xi) - 1);
xx = linspace(0, 10, 200);

figure(1)
plot(xi, yi, '*r'); hold on; grid on
plot(xx, polyval(p, xx), 'b')

% Para ver mas claramente el grafico cambiamos los limites de los ejes
axis([0, 10, min(yi) - 1, max(yi) + 1])

% Se observa que el polinomio no es buena aproximacion a la frontera del
% jardin.
plot(xx, frontera(xx), 'm')
legend('puntos', 'polinomio de interpolacion', 'spline cubico natural')